/*
 * generated by Xtext 2.17.0
 */
package org.xtext.example.mydsl.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder.AbstractGrammarElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class SchemeGrammarAccess extends AbstractGrammarElementFinder {
	
	public class ModelElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.Model");
		private final Assignment cCommandsAssignment = (Assignment)rule.eContents().get(1);
		private final RuleCall cCommandsCommandParserRuleCall_0 = (RuleCall)cCommandsAssignment.eContents().get(0);
		
		///** https://www.scheme.com/tspl4/start.html */ /** Atomic types are: numbers, symbols, booleans, strings, characters */
		//Model:
		//	commands+=Command*;
		@Override public ParserRule getRule() { return rule; }
		
		//commands+=Command*
		public Assignment getCommandsAssignment() { return cCommandsAssignment; }
		
		//Command
		public RuleCall getCommandsCommandParserRuleCall_0() { return cCommandsCommandParserRuleCall_0; }
	}
	public class CommandElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.Command");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cDefineParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cLambdaParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		private final RuleCall cOperationParserRuleCall_2 = (RuleCall)cAlternatives.eContents().get(2);
		private final RuleCall cConditionalParserRuleCall_3 = (RuleCall)cAlternatives.eContents().get(3);
		private final RuleCall cPrintParserRuleCall_4 = (RuleCall)cAlternatives.eContents().get(4);
		private final RuleCall cListaParserRuleCall_5 = (RuleCall)cAlternatives.eContents().get(5);
		
		//Command:
		//	Define | Lambda | Operation | Conditional | Print | Lista;
		@Override public ParserRule getRule() { return rule; }
		
		//Define | Lambda | Operation | Conditional | Print | Lista
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//Define
		public RuleCall getDefineParserRuleCall_0() { return cDefineParserRuleCall_0; }
		
		//Lambda
		public RuleCall getLambdaParserRuleCall_1() { return cLambdaParserRuleCall_1; }
		
		//Operation
		public RuleCall getOperationParserRuleCall_2() { return cOperationParserRuleCall_2; }
		
		//Conditional
		public RuleCall getConditionalParserRuleCall_3() { return cConditionalParserRuleCall_3; }
		
		//Print
		public RuleCall getPrintParserRuleCall_4() { return cPrintParserRuleCall_4; }
		
		//Lista
		public RuleCall getListaParserRuleCall_5() { return cListaParserRuleCall_5; }
	}
	public class DefineElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.Define");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cLeftParenthesisKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cDefineKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cVarUmAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cVarUmSTRINGTerminalRuleCall_2_0 = (RuleCall)cVarUmAssignment_2.eContents().get(0);
		private final Assignment cVarValueAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cVarValueINTTerminalRuleCall_3_0 = (RuleCall)cVarValueAssignment_3.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_4 = (Keyword)cGroup.eContents().get(4);
		
		//Define:
		//	'(' 'define' varUm=STRING varValue=INT ')';
		@Override public ParserRule getRule() { return rule; }
		
		//'(' 'define' varUm=STRING varValue=INT ')'
		public Group getGroup() { return cGroup; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_0() { return cLeftParenthesisKeyword_0; }
		
		//'define'
		public Keyword getDefineKeyword_1() { return cDefineKeyword_1; }
		
		//varUm=STRING
		public Assignment getVarUmAssignment_2() { return cVarUmAssignment_2; }
		
		//STRING
		public RuleCall getVarUmSTRINGTerminalRuleCall_2_0() { return cVarUmSTRINGTerminalRuleCall_2_0; }
		
		//varValue=INT
		public Assignment getVarValueAssignment_3() { return cVarValueAssignment_3; }
		
		//INT
		public RuleCall getVarValueINTTerminalRuleCall_3_0() { return cVarValueINTTerminalRuleCall_3_0; }
		
		//')'
		public Keyword getRightParenthesisKeyword_4() { return cRightParenthesisKeyword_4; }
	}
	public class LambdaElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.Lambda");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cLeftParenthesisKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cLambdaKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cLeftParenthesisKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cParamAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cParamAnyParserRuleCall_3_0 = (RuleCall)cParamAssignment_3.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_4 = (Keyword)cGroup.eContents().get(4);
		private final Keyword cRightParenthesisKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//Lambda:
		//	'(' 'lambda' '(' param+=Any+ ')' ')';
		@Override public ParserRule getRule() { return rule; }
		
		//'(' 'lambda' '(' param+=Any+ ')' ')'
		public Group getGroup() { return cGroup; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_0() { return cLeftParenthesisKeyword_0; }
		
		//'lambda'
		public Keyword getLambdaKeyword_1() { return cLambdaKeyword_1; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_2() { return cLeftParenthesisKeyword_2; }
		
		//param+=Any+
		public Assignment getParamAssignment_3() { return cParamAssignment_3; }
		
		//Any
		public RuleCall getParamAnyParserRuleCall_3_0() { return cParamAnyParserRuleCall_3_0; }
		
		//')'
		public Keyword getRightParenthesisKeyword_4() { return cRightParenthesisKeyword_4; }
		
		//')'
		public Keyword getRightParenthesisKeyword_5() { return cRightParenthesisKeyword_5; }
	}
	public class OperationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.Operation");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cLeftParenthesisKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Alternatives cAlternatives_1 = (Alternatives)cGroup.eContents().get(1);
		private final Assignment cArit_opAssignment_1_0 = (Assignment)cAlternatives_1.eContents().get(0);
		private final RuleCall cArit_opARITHMETIC_OPERATORSTerminalRuleCall_1_0_0 = (RuleCall)cArit_opAssignment_1_0.eContents().get(0);
		private final Assignment cLog_opAssignment_1_1 = (Assignment)cAlternatives_1.eContents().get(1);
		private final RuleCall cLog_opLOGICAL_OPERATORSTerminalRuleCall_1_1_0 = (RuleCall)cLog_opAssignment_1_1.eContents().get(0);
		private final Assignment cRel_opAssignment_1_2 = (Assignment)cAlternatives_1.eContents().get(2);
		private final RuleCall cRel_opRELATIONAL_OPERATORSTerminalRuleCall_1_2_0 = (RuleCall)cRel_opAssignment_1_2.eContents().get(0);
		private final Assignment cValueUmAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cValueUmINTTerminalRuleCall_2_0 = (RuleCall)cValueUmAssignment_2.eContents().get(0);
		private final Assignment cValueDoisAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cValueDoisINTTerminalRuleCall_3_0 = (RuleCall)cValueDoisAssignment_3.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_4 = (Keyword)cGroup.eContents().get(4);
		
		//Operation:
		//	'(' (arit_op=ARITHMETIC_OPERATORS | log_op=LOGICAL_OPERATORS | rel_op=RELATIONAL_OPERATORS) valueUm=INT valueDois=INT
		//	')';
		@Override public ParserRule getRule() { return rule; }
		
		//'(' (arit_op=ARITHMETIC_OPERATORS | log_op=LOGICAL_OPERATORS | rel_op=RELATIONAL_OPERATORS) valueUm=INT valueDois=INT
		//')'
		public Group getGroup() { return cGroup; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_0() { return cLeftParenthesisKeyword_0; }
		
		//arit_op=ARITHMETIC_OPERATORS | log_op=LOGICAL_OPERATORS | rel_op=RELATIONAL_OPERATORS
		public Alternatives getAlternatives_1() { return cAlternatives_1; }
		
		//arit_op=ARITHMETIC_OPERATORS
		public Assignment getArit_opAssignment_1_0() { return cArit_opAssignment_1_0; }
		
		//ARITHMETIC_OPERATORS
		public RuleCall getArit_opARITHMETIC_OPERATORSTerminalRuleCall_1_0_0() { return cArit_opARITHMETIC_OPERATORSTerminalRuleCall_1_0_0; }
		
		//log_op=LOGICAL_OPERATORS
		public Assignment getLog_opAssignment_1_1() { return cLog_opAssignment_1_1; }
		
		//LOGICAL_OPERATORS
		public RuleCall getLog_opLOGICAL_OPERATORSTerminalRuleCall_1_1_0() { return cLog_opLOGICAL_OPERATORSTerminalRuleCall_1_1_0; }
		
		//rel_op=RELATIONAL_OPERATORS
		public Assignment getRel_opAssignment_1_2() { return cRel_opAssignment_1_2; }
		
		//RELATIONAL_OPERATORS
		public RuleCall getRel_opRELATIONAL_OPERATORSTerminalRuleCall_1_2_0() { return cRel_opRELATIONAL_OPERATORSTerminalRuleCall_1_2_0; }
		
		//valueUm=INT
		public Assignment getValueUmAssignment_2() { return cValueUmAssignment_2; }
		
		//INT
		public RuleCall getValueUmINTTerminalRuleCall_2_0() { return cValueUmINTTerminalRuleCall_2_0; }
		
		//valueDois=INT
		public Assignment getValueDoisAssignment_3() { return cValueDoisAssignment_3; }
		
		//INT
		public RuleCall getValueDoisINTTerminalRuleCall_3_0() { return cValueDoisINTTerminalRuleCall_3_0; }
		
		//')'
		public Keyword getRightParenthesisKeyword_4() { return cRightParenthesisKeyword_4; }
	}
	public class ConditionalElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.Conditional");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cLeftParenthesisKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cIfKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cCondAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cCondAnyParserRuleCall_2_0 = (RuleCall)cCondAssignment_2.eContents().get(0);
		private final Assignment cTruthyAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cTruthyAnyParserRuleCall_3_0 = (RuleCall)cTruthyAssignment_3.eContents().get(0);
		private final Assignment cFalsyAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cFalsyAnyParserRuleCall_4_0 = (RuleCall)cFalsyAssignment_4.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//Conditional:
		//	'(' 'if' cond=Any truthy=Any falsy=Any ')';
		@Override public ParserRule getRule() { return rule; }
		
		//'(' 'if' cond=Any truthy=Any falsy=Any ')'
		public Group getGroup() { return cGroup; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_0() { return cLeftParenthesisKeyword_0; }
		
		//'if'
		public Keyword getIfKeyword_1() { return cIfKeyword_1; }
		
		//cond=Any
		public Assignment getCondAssignment_2() { return cCondAssignment_2; }
		
		//Any
		public RuleCall getCondAnyParserRuleCall_2_0() { return cCondAnyParserRuleCall_2_0; }
		
		//truthy=Any
		public Assignment getTruthyAssignment_3() { return cTruthyAssignment_3; }
		
		//Any
		public RuleCall getTruthyAnyParserRuleCall_3_0() { return cTruthyAnyParserRuleCall_3_0; }
		
		//falsy=Any
		public Assignment getFalsyAssignment_4() { return cFalsyAssignment_4; }
		
		//Any
		public RuleCall getFalsyAnyParserRuleCall_4_0() { return cFalsyAnyParserRuleCall_4_0; }
		
		//')'
		public Keyword getRightParenthesisKeyword_5() { return cRightParenthesisKeyword_5; }
	}
	public class PrintElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.Print");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cPrintKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cStringAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cStringSTRINGTerminalRuleCall_1_0 = (RuleCall)cStringAssignment_1.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_2 = (Keyword)cGroup.eContents().get(2);
		
		//Print:
		//	'(print' string=STRING ')';
		@Override public ParserRule getRule() { return rule; }
		
		//'(print' string=STRING ')'
		public Group getGroup() { return cGroup; }
		
		//'(print'
		public Keyword getPrintKeyword_0() { return cPrintKeyword_0; }
		
		//string=STRING
		public Assignment getStringAssignment_1() { return cStringAssignment_1; }
		
		//STRING
		public RuleCall getStringSTRINGTerminalRuleCall_1_0() { return cStringSTRINGTerminalRuleCall_1_0; }
		
		//')'
		public Keyword getRightParenthesisKeyword_2() { return cRightParenthesisKeyword_2; }
	}
	public class ListaElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.Lista");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cLeftParenthesisKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cDefineKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cArrKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Keyword cLeftParenthesisKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Keyword cVectorKeyword_4 = (Keyword)cGroup.eContents().get(4);
		private final Assignment cNumerosAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cNumerosINTTerminalRuleCall_5_0 = (RuleCall)cNumerosAssignment_5.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_6 = (Keyword)cGroup.eContents().get(6);
		private final Keyword cRightParenthesisKeyword_7 = (Keyword)cGroup.eContents().get(7);
		
		//Lista:
		//	'(' 'define' 'arr' '(' 'vector ' numeros+=INT+ ')' ')';
		@Override public ParserRule getRule() { return rule; }
		
		//'(' 'define' 'arr' '(' 'vector ' numeros+=INT+ ')' ')'
		public Group getGroup() { return cGroup; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_0() { return cLeftParenthesisKeyword_0; }
		
		//'define'
		public Keyword getDefineKeyword_1() { return cDefineKeyword_1; }
		
		//'arr'
		public Keyword getArrKeyword_2() { return cArrKeyword_2; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_3() { return cLeftParenthesisKeyword_3; }
		
		//'vector '
		public Keyword getVectorKeyword_4() { return cVectorKeyword_4; }
		
		//numeros+=INT+
		public Assignment getNumerosAssignment_5() { return cNumerosAssignment_5; }
		
		//INT
		public RuleCall getNumerosINTTerminalRuleCall_5_0() { return cNumerosINTTerminalRuleCall_5_0; }
		
		//')'
		public Keyword getRightParenthesisKeyword_6() { return cRightParenthesisKeyword_6; }
		
		//')'
		public Keyword getRightParenthesisKeyword_7() { return cRightParenthesisKeyword_7; }
	}
	public class AnyElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.Any");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final Assignment cAnyIDAssignment_0 = (Assignment)cAlternatives.eContents().get(0);
		private final RuleCall cAnyIDIDTerminalRuleCall_0_0 = (RuleCall)cAnyIDAssignment_0.eContents().get(0);
		private final Assignment cAnyIntAssignment_1 = (Assignment)cAlternatives.eContents().get(1);
		private final RuleCall cAnyIntINTTerminalRuleCall_1_0 = (RuleCall)cAnyIntAssignment_1.eContents().get(0);
		private final Assignment cAnyStringAssignment_2 = (Assignment)cAlternatives.eContents().get(2);
		private final RuleCall cAnyStringSTRINGTerminalRuleCall_2_0 = (RuleCall)cAnyStringAssignment_2.eContents().get(0);
		private final Assignment cAnyDefineAssignment_3 = (Assignment)cAlternatives.eContents().get(3);
		private final RuleCall cAnyDefineDefineParserRuleCall_3_0 = (RuleCall)cAnyDefineAssignment_3.eContents().get(0);
		private final Assignment cAnyLambdaAssignment_4 = (Assignment)cAlternatives.eContents().get(4);
		private final RuleCall cAnyLambdaLambdaParserRuleCall_4_0 = (RuleCall)cAnyLambdaAssignment_4.eContents().get(0);
		private final Assignment cAnyOperationAssignment_5 = (Assignment)cAlternatives.eContents().get(5);
		private final RuleCall cAnyOperationOperationParserRuleCall_5_0 = (RuleCall)cAnyOperationAssignment_5.eContents().get(0);
		private final Assignment cAnyConditionalAssignment_6 = (Assignment)cAlternatives.eContents().get(6);
		private final RuleCall cAnyConditionalConditionalParserRuleCall_6_0 = (RuleCall)cAnyConditionalAssignment_6.eContents().get(0);
		
		//Any:
		//	anyID=ID | anyInt=INT | anyString=STRING | anyDefine=Define | anyLambda=Lambda | anyOperation=Operation |
		//	anyConditional=Conditional;
		@Override public ParserRule getRule() { return rule; }
		
		//anyID=ID | anyInt=INT | anyString=STRING | anyDefine=Define | anyLambda=Lambda | anyOperation=Operation |
		//anyConditional=Conditional
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//anyID=ID
		public Assignment getAnyIDAssignment_0() { return cAnyIDAssignment_0; }
		
		//ID
		public RuleCall getAnyIDIDTerminalRuleCall_0_0() { return cAnyIDIDTerminalRuleCall_0_0; }
		
		//anyInt=INT
		public Assignment getAnyIntAssignment_1() { return cAnyIntAssignment_1; }
		
		//INT
		public RuleCall getAnyIntINTTerminalRuleCall_1_0() { return cAnyIntINTTerminalRuleCall_1_0; }
		
		//anyString=STRING
		public Assignment getAnyStringAssignment_2() { return cAnyStringAssignment_2; }
		
		//STRING
		public RuleCall getAnyStringSTRINGTerminalRuleCall_2_0() { return cAnyStringSTRINGTerminalRuleCall_2_0; }
		
		//anyDefine=Define
		public Assignment getAnyDefineAssignment_3() { return cAnyDefineAssignment_3; }
		
		//Define
		public RuleCall getAnyDefineDefineParserRuleCall_3_0() { return cAnyDefineDefineParserRuleCall_3_0; }
		
		//anyLambda=Lambda
		public Assignment getAnyLambdaAssignment_4() { return cAnyLambdaAssignment_4; }
		
		//Lambda
		public RuleCall getAnyLambdaLambdaParserRuleCall_4_0() { return cAnyLambdaLambdaParserRuleCall_4_0; }
		
		//anyOperation=Operation
		public Assignment getAnyOperationAssignment_5() { return cAnyOperationAssignment_5; }
		
		//Operation
		public RuleCall getAnyOperationOperationParserRuleCall_5_0() { return cAnyOperationOperationParserRuleCall_5_0; }
		
		//anyConditional=Conditional
		public Assignment getAnyConditionalAssignment_6() { return cAnyConditionalAssignment_6; }
		
		//Conditional
		public RuleCall getAnyConditionalConditionalParserRuleCall_6_0() { return cAnyConditionalConditionalParserRuleCall_6_0; }
	}
	
	
	private final ModelElements pModel;
	private final CommandElements pCommand;
	private final DefineElements pDefine;
	private final LambdaElements pLambda;
	private final TerminalRule tARITHMETIC_OPERATORS;
	private final TerminalRule tLOGICAL_OPERATORS;
	private final TerminalRule tRELATIONAL_OPERATORS;
	private final OperationElements pOperation;
	private final ConditionalElements pConditional;
	private final PrintElements pPrint;
	private final ListaElements pLista;
	private final AnyElements pAny;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public SchemeGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pModel = new ModelElements();
		this.pCommand = new CommandElements();
		this.pDefine = new DefineElements();
		this.pLambda = new LambdaElements();
		this.tARITHMETIC_OPERATORS = (TerminalRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.ARITHMETIC_OPERATORS");
		this.tLOGICAL_OPERATORS = (TerminalRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.LOGICAL_OPERATORS");
		this.tRELATIONAL_OPERATORS = (TerminalRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.mydsl.Scheme.RELATIONAL_OPERATORS");
		this.pOperation = new OperationElements();
		this.pConditional = new ConditionalElements();
		this.pPrint = new PrintElements();
		this.pLista = new ListaElements();
		this.pAny = new AnyElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("org.xtext.example.mydsl.Scheme".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	///** https://www.scheme.com/tspl4/start.html */ /** Atomic types are: numbers, symbols, booleans, strings, characters */
	//Model:
	//	commands+=Command*;
	public ModelElements getModelAccess() {
		return pModel;
	}
	
	public ParserRule getModelRule() {
		return getModelAccess().getRule();
	}
	
	//Command:
	//	Define | Lambda | Operation | Conditional | Print | Lista;
	public CommandElements getCommandAccess() {
		return pCommand;
	}
	
	public ParserRule getCommandRule() {
		return getCommandAccess().getRule();
	}
	
	//Define:
	//	'(' 'define' varUm=STRING varValue=INT ')';
	public DefineElements getDefineAccess() {
		return pDefine;
	}
	
	public ParserRule getDefineRule() {
		return getDefineAccess().getRule();
	}
	
	//Lambda:
	//	'(' 'lambda' '(' param+=Any+ ')' ')';
	public LambdaElements getLambdaAccess() {
		return pLambda;
	}
	
	public ParserRule getLambdaRule() {
		return getLambdaAccess().getRule();
	}
	
	//terminal ARITHMETIC_OPERATORS:
	//	'+' | '-' | '*' | '/' | 'abs' | 'sqrt';
	public TerminalRule getARITHMETIC_OPERATORSRule() {
		return tARITHMETIC_OPERATORS;
	}
	
	//terminal LOGICAL_OPERATORS:
	//	'and' | 'or' | 'not';
	public TerminalRule getLOGICAL_OPERATORSRule() {
		return tLOGICAL_OPERATORS;
	}
	
	//terminal RELATIONAL_OPERATORS:
	//	'>' | '<' | '=' | '>=' | '=<';
	public TerminalRule getRELATIONAL_OPERATORSRule() {
		return tRELATIONAL_OPERATORS;
	}
	
	//Operation:
	//	'(' (arit_op=ARITHMETIC_OPERATORS | log_op=LOGICAL_OPERATORS | rel_op=RELATIONAL_OPERATORS) valueUm=INT valueDois=INT
	//	')';
	public OperationElements getOperationAccess() {
		return pOperation;
	}
	
	public ParserRule getOperationRule() {
		return getOperationAccess().getRule();
	}
	
	//Conditional:
	//	'(' 'if' cond=Any truthy=Any falsy=Any ')';
	public ConditionalElements getConditionalAccess() {
		return pConditional;
	}
	
	public ParserRule getConditionalRule() {
		return getConditionalAccess().getRule();
	}
	
	//Print:
	//	'(print' string=STRING ')';
	public PrintElements getPrintAccess() {
		return pPrint;
	}
	
	public ParserRule getPrintRule() {
		return getPrintAccess().getRule();
	}
	
	//Lista:
	//	'(' 'define' 'arr' '(' 'vector ' numeros+=INT+ ')' ')';
	public ListaElements getListaAccess() {
		return pLista;
	}
	
	public ParserRule getListaRule() {
		return getListaAccess().getRule();
	}
	
	//Any:
	//	anyID=ID | anyInt=INT | anyString=STRING | anyDefine=Define | anyLambda=Lambda | anyOperation=Operation |
	//	anyConditional=Conditional;
	public AnyElements getAnyAccess() {
		return pAny;
	}
	
	public ParserRule getAnyRule() {
		return getAnyAccess().getRule();
	}
	
	//terminal ID:
	//	'^'? ('a'..'z' | 'A'..'Z' | '_') ('a'..'z' | 'A'..'Z' | '_' | '0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt:
	//	'0'..'9'+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//	'"' ('\\' . | !('\\' | '"'))* '"' |
	//	"'" ('\\' . | !('\\' | "'"))* "'";
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT:
	//	'/*'->'*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT:
	//	'//' !('\n' | '\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS:
	//	' ' | '\t' | '\r' | '\n'+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER:
	//	.;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
